# -*- coding: utf-8 -*-
"""
Created on Mon Mar 18 18:27:43 2019

@author: l070j502
"""


###main

class Student:
    def __init__(self,email,city,campus,block,date_sign_in):
        self.email=email
        self.city=city
        self.campus=campus
        self.blocks=block
        self.date_sign_in=date_sign_in
        
    def show(self):
        print('Email:',self.email)
        print('city:',self.city)
        print('campus:',self.campus)
        print('blocks:',self.blocks)
        print('date:',self.date_sign_in)
        
    def __str__(self):
        return self.email + " " + self.city + " " + \
            self.campus + " " + str(self.blocks) + " "+ \
            str(self.date_sign_in)



class DoublyNode:
  def __init__(self, e, n=None, p=None ):
    self.element = e
    self.next = n
    self.prev = p

class StudentsList:
  def __init__(self):
    """creates an empty list"""
    self.head=None
    self.tail=None
    self.size=0
    
  def isEmpty(self):
    """Checks if the list is empty"""
    return self.head is None   
  
  def existEmail(self,email):
    """checks if the email already exists into the list"""
    
    current=self.head
    #we traverse the nodes while found is not True. 
    while current:
      if current.element.email is email:
        return True
      current=current.next
      
    return False    


  def addFirst(self,e):
    
    """Add a new element, e, at the beginning of the list"""
    
    if type(e)!=Student: 
        print(type(e))
        print('the element should be a student object')
        return
    
    if self.existEmail(e.email):
        print(e.email + " already exists!!!")
        return
    #create the new node
    newNode=DoublyNode(e)
    #the new node must point to the current head
    
    if self.isEmpty():
      self.tail=newNode
    else:
      newNode.next=self.head
      self.head.prev=newNode
      
    #update the reference of head to point the new node
    self.head=newNode
    #increase the size of the list  
    self.size=self.size+1
    
    
  def addLast(self,e):
    """Add a new element, e, at the end of the list"""
    
    if type(e)!=Student: 
        print(type(e))
        print('the element should be a student object')
        return

    if self.existEmail(e.email):
        print(e.email + " already exists!!!")
        return


    #create the new node
    newNode=DoublyNode(e)
    
    if self.isEmpty():
      self.head=newNode
    else:
      newNode.prev=self.tail
      self.tail.next=newNode
      
    #update the reference of head to point the new node
    self.tail=newNode
    #increase the size of the list  
    self.size=self.size+1
   
  
  def __str__(self):
    """Returns a string with the elements of the list"""
    temp=self.head
    strList=''
    while temp is not None:
      strList=strList+'\n'+str(temp.element)
      temp=temp.next
    return strList[1:]+'\n'
  
  def removeFirst(self):
    """Returns and remove the first element of the list"""
    if self.isEmpty():
      print("Error: list is empty")
      return None
    
    result=self.head.element 
    self.head= self.head.next 
    if self.head is None:
      self.tail=None
    else:
      self.head.prev = None

    self.size=self.size-1
    return result
  
  def removeLast(self):
    """Returns and remove the last element of the list"""
    if self.isEmpty():
      print("Error: list is empty")
      return None
    
    result=self.tail.element 
    self.tail= self.tail.prev 
    if self.tail is None:
      self.head=None
    else:
      self.tail.next = None

    self.size=self.size-1
    return result
  
  
  def insertAt(self,index,e):
    """It inserts the element e at the index position of the list"""
    if type(e)!=Student: 
        print('the element should be a student object')
        return

    if self.existEmail(e.email):
        print(e.email + " already exists!!!")
        return


    if index<0 or index>self.size:
      print('Error: index out of range')
      return
    
    if index==0:
      self.addFirst(e)
    elif index==self.size: 
	    self.addLast(e)
    else:
      i=0
      aux=self.head
      while i<index:
        aux=aux.next
        i=i+1
      #aux is the node at the index position
      previous=aux.prev
      newNode=DoublyNode(e)
      newNode.next=aux
      newNode.prev=previous
      aux.prev=newNode
      previous.next=newNode
      self.size= self.size+1
   
  def insertSort(self,e,opc):
    """Method that inserts in sorted way"""
    if type(e)!=Student: 
      print('the element should be a student object')
      return
    
    if self.isEmpty():
        self.addLast(e)
        return
    
    node=self.head

    if opc==1:    
        while node and node.element.email<=e.email:
            node=node.next
    else:
        while node and node.element.email>=e.email:
            node=node.next
        
    if node is None:
        self.addLast(e)
        return
    
    #we must insert before node
    prev=node.prev
    if prev is None:
        self.addFirst(e)
    else:
        newNode=DoublyNode(e)
        newNode.next=node
        newNode.prev=prev
        prev.next=newNode
        node.prev=newNode
        self.size+=1
        
    return


      
  def getAt(self,index):
    """Returns the element at the index position in the list"""
    
    #first, check the index is a right position in the list
    if index<0 or index>=self.size:
      print(index,'error: index out of range')
      return None
      
    #we need to reach the node at the index position in the list
    i=0
    current=self.head
    while  i<index:
      current=current.next
      i+=1
    #here, current is the node at the index position in the list
    #we return its element
    return current.element
      
      
  def contains(self,e):
    """It returns the first position of e into the list. If the element 
    does no exist, then it returns -1"""
    
    if type(e)!=Student: 
        print('the element should be a student object')
        return

    index=-1
    
    found=False
    
    current=self.head
    #we traverse the nodes while found is not True. 
    while current is not None and found==False:
      if current.element==e:
        found=True   #the loop condition becomes False
      current=current.next
      index=index+1
    
    #Warning: if e does not exist,  
    #index is the number of nodes in the list    
    if found:
      return index
    else:
      return -1
    
  def removeAt(self,index):
    """This methods removes the node at the index position in the list"""
    
    #We must check that index is a right position in the list
    #Remember that the indexes in a list can range from 0 to size-1
    if index<0 or index>=self.size:
      print(index,'Error: index out of range')
      return 
       
    if index==0:
      self.removeFirst()
    elif index==self.size-1:
      self.removeLast()
    else:
      #we must to reach the node at the index position
      i=0
      node=self.head
      while i<index:
        node=node.next
        i=i+1
      
      prevNode=node.prev
      nextNode=node.next
      
      prevNode.next=nextNode
      nextNode.prev=prevNode
      self.size=self.size-1



  def show(self,opc):
    result=''
    if opc==0:
      node=self.head
      while node:
        result += str(node.element)+ ' \n'
        node=node.next
    else:
      node=self.tail
      while node:
        result += str(node.element)+ '\n'
        node=node.prev
    print(result[:-1])

class ManageNetworkList:
    
    def merge(self,net1,net2):
        """1.	Create a method, named merge,  that merges two social 
        networks into one by alternating their students.   
        That is, the method takes two objects of the StudentsList 
        and returns a new list which alternates the students from 
        both social networks. The new list must not contain repeated students. """
        if type(net1)!=StudentsList:
            print('The first parameter should be a StudentsList object')
            return
        if type(net2)!=StudentsList:
            print('The second parameter should be a StudentsList object')
            return
        
        network=StudentsList()
        min_size=min(net1.size,net2.size)
        for i in range(min_size):
            network.addLast(net1.getAt(i))
            network.addLast(net2.getAt(i))
        
        for i in range(min_size,net1.size):
            network.addLast(net1.getAt(i))
            
        for i in range(min_size,net2.size):
            network.addLast(net2.getAt(i))
            
        return network
        
    def getCampusCity(self,net,opc):
        """2.	Create a method getCampusCity taking a social network (that is, an object of the StudentsList class) as input and an integer parameter opc so that:
            If opc =1: the method must return a StudentsList object containing all the students residing in the same city that the campus where they are studying.
            If opc =2: the method must return a StudentsList object containing all the students residing in cities different that the one where their campus is located.
            Note: The order in the resulting list must be the same that in the input list."""
            
        if type(net)!=StudentsList:
            print('The parameter should be a StudentsList object')
            return
        
        network=StudentsList()
        if opc==1: 
            for i in range(net.size):
                s=net.getAt(i)
                if s.city==s.campus:
                    network.addLast(s)
        elif opc==2:
            for i in range(net.size):
                s=net.getAt(i)
                if s.city!=s.campus:
                    network.addLast(s)
        else:
            print('parameter no valid')
        
        return network

    def locateByCity(self,net,city):
        """3.	Create a method locateByCity taking a social network (that is, 
        an object of the StudentsList class) and a city name as input and returning 
        a list containing all the students (that is, an object of the StudentsList class) 
        who live in that city. Note: The order in the resulting list must be the same that in the input list."""

        if type(net)!=StudentsList:
            print('The parameter should be a StudentsList object')
            return
        
        network=StudentsList()
        for i in range(net.size):
            s=net.getAt(i)
            if s.city==city:
                network.addLast(s)
       
        return network
        
    def orderBy(self,net,opc):
        """4.	Create a method orderBy having a social network (that is, an object of the StudentsList class) as input and an integer parameter opc so that: 
            If opc=1, the method returns a new list of students (that is, an object of the StudentsList class)  sorted by ascending order according to their email.
            If opc=2, the method returns a new list of students (that is, an object of the StudentsList class) sorted by descending order according to their email.
            """
        if type(net)!=StudentsList:
            print('The parameter should be a StudentsList object')
            return
        
        network=StudentsList()
        for i in range(net.size):
            s=net.getAt(i)
            network.insertSort(s,opc)
        return network

    def getStudentsByDateInterval(self,net,date1,date2):
        """5.	Create a method getStudentsByDateInterval, which takes a social 
        network (an object of the StudentsList class) and two dates (start and end), 
        and returns the list of all students from the input social network whose registration 
        dates are in this interval of dates. """
        if type(net)!=StudentsList:
            print('The parameter should be a StudentsList object')
            return
        
        network=StudentsList()
        for i in range(net.size):
            s=net.getAt(i)
            if date1<=s.date_sign_in and s.date_sign_in<=date2:
                network.addLast(s)

        return network
    
    
